// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include "part_data.hxx"

// part_data_t
// 

const part_data_t::config_data_type& part_data_t::
config_data () const
{
  return this->config_data_.get ();
}

part_data_t::config_data_type& part_data_t::
config_data ()
{
  return this->config_data_.get ();
}

void part_data_t::
config_data (const config_data_type& x)
{
  this->config_data_.set (x);
}

void part_data_t::
config_data (::std::unique_ptr< config_data_type > x)
{
  this->config_data_.set (std::move (x));
}

const part_data_t::general_part_info_sequence& part_data_t::
general_part_info () const
{
  return this->general_part_info_;
}

part_data_t::general_part_info_sequence& part_data_t::
general_part_info ()
{
  return this->general_part_info_;
}

void part_data_t::
general_part_info (const general_part_info_sequence& s)
{
  this->general_part_info_ = s;
}

const part_data_t::cuboid_sequence& part_data_t::
cuboid () const
{
  return this->cuboid_;
}

part_data_t::cuboid_sequence& part_data_t::
cuboid ()
{
  return this->cuboid_;
}

void part_data_t::
cuboid (const cuboid_sequence& s)
{
  this->cuboid_ = s;
}

const part_data_t::sphere_2Dz_sequence& part_data_t::
sphere_2Dz () const
{
  return this->sphere_2Dz_;
}

part_data_t::sphere_2Dz_sequence& part_data_t::
sphere_2Dz ()
{
  return this->sphere_2Dz_;
}

void part_data_t::
sphere_2Dz (const sphere_2Dz_sequence& s)
{
  this->sphere_2Dz_ = s;
}


// config_data
// 

const config_data::brownian_motion_type& config_data::
brownian_motion () const
{
  return this->brownian_motion_.get ();
}

config_data::brownian_motion_type& config_data::
brownian_motion ()
{
  return this->brownian_motion_.get ();
}

void config_data::
brownian_motion (const brownian_motion_type& x)
{
  this->brownian_motion_.set (x);
}

const config_data::num_dim_of_sim_type& config_data::
num_dim_of_sim () const
{
  return this->num_dim_of_sim_.get ();
}

config_data::num_dim_of_sim_type& config_data::
num_dim_of_sim ()
{
  return this->num_dim_of_sim_.get ();
}

void config_data::
num_dim_of_sim (const num_dim_of_sim_type& x)
{
  this->num_dim_of_sim_.set (x);
}

const config_data::num_particle_types_type& config_data::
num_particle_types () const
{
  return this->num_particle_types_.get ();
}

config_data::num_particle_types_type& config_data::
num_particle_types ()
{
  return this->num_particle_types_.get ();
}

void config_data::
num_particle_types (const num_particle_types_type& x)
{
  this->num_particle_types_.set (x);
}

const config_data::num_objects_type& config_data::
num_objects () const
{
  return this->num_objects_.get ();
}

config_data::num_objects_type& config_data::
num_objects ()
{
  return this->num_objects_.get ();
}

void config_data::
num_objects (const num_objects_type& x)
{
  this->num_objects_.set (x);
}

const config_data::num_cuboids_type& config_data::
num_cuboids () const
{
  return this->num_cuboids_.get ();
}

config_data::num_cuboids_type& config_data::
num_cuboids ()
{
  return this->num_cuboids_.get ();
}

void config_data::
num_cuboids (const num_cuboids_type& x)
{
  this->num_cuboids_.set (x);
}

const config_data::num_spheres_type& config_data::
num_spheres () const
{
  return this->num_spheres_.get ();
}

config_data::num_spheres_type& config_data::
num_spheres ()
{
  return this->num_spheres_.get ();
}

void config_data::
num_spheres (const num_spheres_type& x)
{
  this->num_spheres_.set (x);
}


// general_part_info
// 

const general_part_info::sigma_type& general_part_info::
sigma () const
{
  return this->sigma_.get ();
}

general_part_info::sigma_type& general_part_info::
sigma ()
{
  return this->sigma_.get ();
}

void general_part_info::
sigma (const sigma_type& x)
{
  this->sigma_.set (x);
}

const general_part_info::epsilon_type& general_part_info::
epsilon () const
{
  return this->epsilon_.get ();
}

general_part_info::epsilon_type& general_part_info::
epsilon ()
{
  return this->epsilon_.get ();
}

void general_part_info::
epsilon (const epsilon_type& x)
{
  this->epsilon_.set (x);
}

const general_part_info::mass_type& general_part_info::
mass () const
{
  return this->mass_.get ();
}

general_part_info::mass_type& general_part_info::
mass ()
{
  return this->mass_.get ();
}

void general_part_info::
mass (const mass_type& x)
{
  this->mass_.set (x);
}


// cuboid
// 

const cuboid::type_type& cuboid::
type () const
{
  return this->type_.get ();
}

cuboid::type_type& cuboid::
type ()
{
  return this->type_.get ();
}

void cuboid::
type (const type_type& x)
{
  this->type_.set (x);
}

const cuboid::distance_type& cuboid::
distance () const
{
  return this->distance_.get ();
}

cuboid::distance_type& cuboid::
distance ()
{
  return this->distance_.get ();
}

void cuboid::
distance (const distance_type& x)
{
  this->distance_.set (x);
}

const cuboid::left_corner_type& cuboid::
left_corner () const
{
  return this->left_corner_.get ();
}

cuboid::left_corner_type& cuboid::
left_corner ()
{
  return this->left_corner_.get ();
}

void cuboid::
left_corner (const left_corner_type& x)
{
  this->left_corner_.set (x);
}

void cuboid::
left_corner (::std::unique_ptr< left_corner_type > x)
{
  this->left_corner_.set (std::move (x));
}

const cuboid::velocity_type& cuboid::
velocity () const
{
  return this->velocity_.get ();
}

cuboid::velocity_type& cuboid::
velocity ()
{
  return this->velocity_.get ();
}

void cuboid::
velocity (const velocity_type& x)
{
  this->velocity_.set (x);
}

void cuboid::
velocity (::std::unique_ptr< velocity_type > x)
{
  this->velocity_.set (std::move (x));
}

const cuboid::dimensions_type& cuboid::
dimensions () const
{
  return this->dimensions_.get ();
}

cuboid::dimensions_type& cuboid::
dimensions ()
{
  return this->dimensions_.get ();
}

void cuboid::
dimensions (const dimensions_type& x)
{
  this->dimensions_.set (x);
}

void cuboid::
dimensions (::std::unique_ptr< dimensions_type > x)
{
  this->dimensions_.set (std::move (x));
}


// sphere_2Dz
// 

const sphere_2Dz::type_type& sphere_2Dz::
type () const
{
  return this->type_.get ();
}

sphere_2Dz::type_type& sphere_2Dz::
type ()
{
  return this->type_.get ();
}

void sphere_2Dz::
type (const type_type& x)
{
  this->type_.set (x);
}

const sphere_2Dz::distance_type& sphere_2Dz::
distance () const
{
  return this->distance_.get ();
}

sphere_2Dz::distance_type& sphere_2Dz::
distance ()
{
  return this->distance_.get ();
}

void sphere_2Dz::
distance (const distance_type& x)
{
  this->distance_.set (x);
}

const sphere_2Dz::radius_type& sphere_2Dz::
radius () const
{
  return this->radius_.get ();
}

sphere_2Dz::radius_type& sphere_2Dz::
radius ()
{
  return this->radius_.get ();
}

void sphere_2Dz::
radius (const radius_type& x)
{
  this->radius_.set (x);
}

const sphere_2Dz::center_type& sphere_2Dz::
center () const
{
  return this->center_.get ();
}

sphere_2Dz::center_type& sphere_2Dz::
center ()
{
  return this->center_.get ();
}

void sphere_2Dz::
center (const center_type& x)
{
  this->center_.set (x);
}

void sphere_2Dz::
center (::std::unique_ptr< center_type > x)
{
  this->center_.set (std::move (x));
}

const sphere_2Dz::velocity_type& sphere_2Dz::
velocity () const
{
  return this->velocity_.get ();
}

sphere_2Dz::velocity_type& sphere_2Dz::
velocity ()
{
  return this->velocity_.get ();
}

void sphere_2Dz::
velocity (const velocity_type& x)
{
  this->velocity_.set (x);
}

void sphere_2Dz::
velocity (::std::unique_ptr< velocity_type > x)
{
  this->velocity_.set (std::move (x));
}


// left_corner
// 

const left_corner::left_corner_x_type& left_corner::
left_corner_x () const
{
  return this->left_corner_x_.get ();
}

left_corner::left_corner_x_type& left_corner::
left_corner_x ()
{
  return this->left_corner_x_.get ();
}

void left_corner::
left_corner_x (const left_corner_x_type& x)
{
  this->left_corner_x_.set (x);
}

const left_corner::left_corner_y_type& left_corner::
left_corner_y () const
{
  return this->left_corner_y_.get ();
}

left_corner::left_corner_y_type& left_corner::
left_corner_y ()
{
  return this->left_corner_y_.get ();
}

void left_corner::
left_corner_y (const left_corner_y_type& x)
{
  this->left_corner_y_.set (x);
}

const left_corner::left_corner_z_type& left_corner::
left_corner_z () const
{
  return this->left_corner_z_.get ();
}

left_corner::left_corner_z_type& left_corner::
left_corner_z ()
{
  return this->left_corner_z_.get ();
}

void left_corner::
left_corner_z (const left_corner_z_type& x)
{
  this->left_corner_z_.set (x);
}


// velocity
// 

const velocity::velo_x_type& velocity::
velo_x () const
{
  return this->velo_x_.get ();
}

velocity::velo_x_type& velocity::
velo_x ()
{
  return this->velo_x_.get ();
}

void velocity::
velo_x (const velo_x_type& x)
{
  this->velo_x_.set (x);
}

const velocity::velo_y_type& velocity::
velo_y () const
{
  return this->velo_y_.get ();
}

velocity::velo_y_type& velocity::
velo_y ()
{
  return this->velo_y_.get ();
}

void velocity::
velo_y (const velo_y_type& x)
{
  this->velo_y_.set (x);
}

const velocity::velo_z_type& velocity::
velo_z () const
{
  return this->velo_z_.get ();
}

velocity::velo_z_type& velocity::
velo_z ()
{
  return this->velo_z_.get ();
}

void velocity::
velo_z (const velo_z_type& x)
{
  this->velo_z_.set (x);
}


// dimensions
// 

const dimensions::dim_x_type& dimensions::
dim_x () const
{
  return this->dim_x_.get ();
}

dimensions::dim_x_type& dimensions::
dim_x ()
{
  return this->dim_x_.get ();
}

void dimensions::
dim_x (const dim_x_type& x)
{
  this->dim_x_.set (x);
}

const dimensions::dim_y_type& dimensions::
dim_y () const
{
  return this->dim_y_.get ();
}

dimensions::dim_y_type& dimensions::
dim_y ()
{
  return this->dim_y_.get ();
}

void dimensions::
dim_y (const dim_y_type& x)
{
  this->dim_y_.set (x);
}

const dimensions::dim_z_type& dimensions::
dim_z () const
{
  return this->dim_z_.get ();
}

dimensions::dim_z_type& dimensions::
dim_z ()
{
  return this->dim_z_.get ();
}

void dimensions::
dim_z (const dim_z_type& x)
{
  this->dim_z_.set (x);
}


// center
// 

const center::center_x_type& center::
center_x () const
{
  return this->center_x_.get ();
}

center::center_x_type& center::
center_x ()
{
  return this->center_x_.get ();
}

void center::
center_x (const center_x_type& x)
{
  this->center_x_.set (x);
}

const center::center_y_type& center::
center_y () const
{
  return this->center_y_.get ();
}

center::center_y_type& center::
center_y ()
{
  return this->center_y_.get ();
}

void center::
center_y (const center_y_type& x)
{
  this->center_y_.set (x);
}

const center::center_z_type& center::
center_z () const
{
  return this->center_z_.get ();
}

center::center_z_type& center::
center_z ()
{
  return this->center_z_.get ();
}

void center::
center_z (const center_z_type& x)
{
  this->center_z_.set (x);
}


#include <xsd/cxx/xml/dom/parsing-source.hxx>

// part_data_t
//

part_data_t::
part_data_t (const config_data_type& config_data)
: ::xml_schema::type (),
  config_data_ (config_data, this),
  general_part_info_ (this),
  cuboid_ (this),
  sphere_2Dz_ (this)
{
}

part_data_t::
part_data_t (::std::unique_ptr< config_data_type > config_data)
: ::xml_schema::type (),
  config_data_ (std::move (config_data), this),
  general_part_info_ (this),
  cuboid_ (this),
  sphere_2Dz_ (this)
{
}

part_data_t::
part_data_t (const part_data_t& x,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  config_data_ (x.config_data_, f, this),
  general_part_info_ (x.general_part_info_, f, this),
  cuboid_ (x.cuboid_, f, this),
  sphere_2Dz_ (x.sphere_2Dz_, f, this)
{
}

part_data_t::
part_data_t (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  config_data_ (this),
  general_part_info_ (this),
  cuboid_ (this),
  sphere_2Dz_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void part_data_t::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // config_data
    //
    if (n.name () == "config_data" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< config_data_type > r (
        config_data_traits::create (i, f, this));

      if (!config_data_.present ())
      {
        this->config_data_.set (::std::move (r));
        continue;
      }
    }

    // general_part_info
    //
    if (n.name () == "general_part_info" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< general_part_info_type > r (
        general_part_info_traits::create (i, f, this));

      this->general_part_info_.push_back (::std::move (r));
      continue;
    }

    // cuboid
    //
    if (n.name () == "cuboid" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< cuboid_type > r (
        cuboid_traits::create (i, f, this));

      this->cuboid_.push_back (::std::move (r));
      continue;
    }

    // sphere_2Dz
    //
    if (n.name () == "sphere_2Dz" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< sphere_2Dz_type > r (
        sphere_2Dz_traits::create (i, f, this));

      this->sphere_2Dz_.push_back (::std::move (r));
      continue;
    }

    break;
  }

  if (!config_data_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "config_data",
      "");
  }
}

part_data_t* part_data_t::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class part_data_t (*this, f, c);
}

part_data_t& part_data_t::
operator= (const part_data_t& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->config_data_ = x.config_data_;
    this->general_part_info_ = x.general_part_info_;
    this->cuboid_ = x.cuboid_;
    this->sphere_2Dz_ = x.sphere_2Dz_;
  }

  return *this;
}

part_data_t::
~part_data_t ()
{
}

// config_data
//

config_data::
config_data (const brownian_motion_type& brownian_motion,
             const num_dim_of_sim_type& num_dim_of_sim,
             const num_particle_types_type& num_particle_types,
             const num_objects_type& num_objects,
             const num_cuboids_type& num_cuboids,
             const num_spheres_type& num_spheres)
: ::xml_schema::type (),
  brownian_motion_ (brownian_motion, this),
  num_dim_of_sim_ (num_dim_of_sim, this),
  num_particle_types_ (num_particle_types, this),
  num_objects_ (num_objects, this),
  num_cuboids_ (num_cuboids, this),
  num_spheres_ (num_spheres, this)
{
}

config_data::
config_data (const config_data& x,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  brownian_motion_ (x.brownian_motion_, f, this),
  num_dim_of_sim_ (x.num_dim_of_sim_, f, this),
  num_particle_types_ (x.num_particle_types_, f, this),
  num_objects_ (x.num_objects_, f, this),
  num_cuboids_ (x.num_cuboids_, f, this),
  num_spheres_ (x.num_spheres_, f, this)
{
}

config_data::
config_data (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  brownian_motion_ (this),
  num_dim_of_sim_ (this),
  num_particle_types_ (this),
  num_objects_ (this),
  num_cuboids_ (this),
  num_spheres_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void config_data::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // brownian_motion
    //
    if (n.name () == "brownian_motion" && n.namespace_ ().empty ())
    {
      if (!brownian_motion_.present ())
      {
        this->brownian_motion_.set (brownian_motion_traits::create (i, f, this));
        continue;
      }
    }

    // num_dim_of_sim
    //
    if (n.name () == "num_dim_of_sim" && n.namespace_ ().empty ())
    {
      if (!num_dim_of_sim_.present ())
      {
        this->num_dim_of_sim_.set (num_dim_of_sim_traits::create (i, f, this));
        continue;
      }
    }

    // num_particle_types
    //
    if (n.name () == "num_particle_types" && n.namespace_ ().empty ())
    {
      if (!num_particle_types_.present ())
      {
        this->num_particle_types_.set (num_particle_types_traits::create (i, f, this));
        continue;
      }
    }

    // num_objects
    //
    if (n.name () == "num_objects" && n.namespace_ ().empty ())
    {
      if (!num_objects_.present ())
      {
        this->num_objects_.set (num_objects_traits::create (i, f, this));
        continue;
      }
    }

    // num_cuboids
    //
    if (n.name () == "num_cuboids" && n.namespace_ ().empty ())
    {
      if (!num_cuboids_.present ())
      {
        this->num_cuboids_.set (num_cuboids_traits::create (i, f, this));
        continue;
      }
    }

    // num_spheres
    //
    if (n.name () == "num_spheres" && n.namespace_ ().empty ())
    {
      if (!num_spheres_.present ())
      {
        this->num_spheres_.set (num_spheres_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!brownian_motion_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "brownian_motion",
      "");
  }

  if (!num_dim_of_sim_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "num_dim_of_sim",
      "");
  }

  if (!num_particle_types_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "num_particle_types",
      "");
  }

  if (!num_objects_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "num_objects",
      "");
  }

  if (!num_cuboids_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "num_cuboids",
      "");
  }

  if (!num_spheres_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "num_spheres",
      "");
  }
}

config_data* config_data::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class config_data (*this, f, c);
}

config_data& config_data::
operator= (const config_data& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->brownian_motion_ = x.brownian_motion_;
    this->num_dim_of_sim_ = x.num_dim_of_sim_;
    this->num_particle_types_ = x.num_particle_types_;
    this->num_objects_ = x.num_objects_;
    this->num_cuboids_ = x.num_cuboids_;
    this->num_spheres_ = x.num_spheres_;
  }

  return *this;
}

config_data::
~config_data ()
{
}

// general_part_info
//

general_part_info::
general_part_info (const sigma_type& sigma,
                   const epsilon_type& epsilon,
                   const mass_type& mass)
: ::xml_schema::type (),
  sigma_ (sigma, this),
  epsilon_ (epsilon, this),
  mass_ (mass, this)
{
}

general_part_info::
general_part_info (const general_part_info& x,
                   ::xml_schema::flags f,
                   ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  sigma_ (x.sigma_, f, this),
  epsilon_ (x.epsilon_, f, this),
  mass_ (x.mass_, f, this)
{
}

general_part_info::
general_part_info (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f,
                   ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  sigma_ (this),
  epsilon_ (this),
  mass_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void general_part_info::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // sigma
    //
    if (n.name () == "sigma" && n.namespace_ ().empty ())
    {
      if (!sigma_.present ())
      {
        this->sigma_.set (sigma_traits::create (i, f, this));
        continue;
      }
    }

    // epsilon
    //
    if (n.name () == "epsilon" && n.namespace_ ().empty ())
    {
      if (!epsilon_.present ())
      {
        this->epsilon_.set (epsilon_traits::create (i, f, this));
        continue;
      }
    }

    // mass
    //
    if (n.name () == "mass" && n.namespace_ ().empty ())
    {
      if (!mass_.present ())
      {
        this->mass_.set (mass_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!sigma_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "sigma",
      "");
  }

  if (!epsilon_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "epsilon",
      "");
  }

  if (!mass_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "mass",
      "");
  }
}

general_part_info* general_part_info::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class general_part_info (*this, f, c);
}

general_part_info& general_part_info::
operator= (const general_part_info& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->sigma_ = x.sigma_;
    this->epsilon_ = x.epsilon_;
    this->mass_ = x.mass_;
  }

  return *this;
}

general_part_info::
~general_part_info ()
{
}

// cuboid
//

cuboid::
cuboid (const type_type& type,
        const distance_type& distance,
        const left_corner_type& left_corner,
        const velocity_type& velocity,
        const dimensions_type& dimensions)
: ::xml_schema::type (),
  type_ (type, this),
  distance_ (distance, this),
  left_corner_ (left_corner, this),
  velocity_ (velocity, this),
  dimensions_ (dimensions, this)
{
}

cuboid::
cuboid (const type_type& type,
        const distance_type& distance,
        ::std::unique_ptr< left_corner_type > left_corner,
        ::std::unique_ptr< velocity_type > velocity,
        ::std::unique_ptr< dimensions_type > dimensions)
: ::xml_schema::type (),
  type_ (type, this),
  distance_ (distance, this),
  left_corner_ (std::move (left_corner), this),
  velocity_ (std::move (velocity), this),
  dimensions_ (std::move (dimensions), this)
{
}

cuboid::
cuboid (const cuboid& x,
        ::xml_schema::flags f,
        ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  type_ (x.type_, f, this),
  distance_ (x.distance_, f, this),
  left_corner_ (x.left_corner_, f, this),
  velocity_ (x.velocity_, f, this),
  dimensions_ (x.dimensions_, f, this)
{
}

cuboid::
cuboid (const ::xercesc::DOMElement& e,
        ::xml_schema::flags f,
        ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  type_ (this),
  distance_ (this),
  left_corner_ (this),
  velocity_ (this),
  dimensions_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void cuboid::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // type
    //
    if (n.name () == "type" && n.namespace_ ().empty ())
    {
      if (!type_.present ())
      {
        this->type_.set (type_traits::create (i, f, this));
        continue;
      }
    }

    // distance
    //
    if (n.name () == "distance" && n.namespace_ ().empty ())
    {
      if (!distance_.present ())
      {
        this->distance_.set (distance_traits::create (i, f, this));
        continue;
      }
    }

    // left_corner
    //
    if (n.name () == "left_corner" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< left_corner_type > r (
        left_corner_traits::create (i, f, this));

      if (!left_corner_.present ())
      {
        this->left_corner_.set (::std::move (r));
        continue;
      }
    }

    // velocity
    //
    if (n.name () == "velocity" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< velocity_type > r (
        velocity_traits::create (i, f, this));

      if (!velocity_.present ())
      {
        this->velocity_.set (::std::move (r));
        continue;
      }
    }

    // dimensions
    //
    if (n.name () == "dimensions" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< dimensions_type > r (
        dimensions_traits::create (i, f, this));

      if (!dimensions_.present ())
      {
        this->dimensions_.set (::std::move (r));
        continue;
      }
    }

    break;
  }

  if (!type_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "type",
      "");
  }

  if (!distance_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "distance",
      "");
  }

  if (!left_corner_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "left_corner",
      "");
  }

  if (!velocity_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "velocity",
      "");
  }

  if (!dimensions_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "dimensions",
      "");
  }
}

cuboid* cuboid::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class cuboid (*this, f, c);
}

cuboid& cuboid::
operator= (const cuboid& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->type_ = x.type_;
    this->distance_ = x.distance_;
    this->left_corner_ = x.left_corner_;
    this->velocity_ = x.velocity_;
    this->dimensions_ = x.dimensions_;
  }

  return *this;
}

cuboid::
~cuboid ()
{
}

// sphere_2Dz
//

sphere_2Dz::
sphere_2Dz (const type_type& type,
            const distance_type& distance,
            const radius_type& radius,
            const center_type& center,
            const velocity_type& velocity)
: ::xml_schema::type (),
  type_ (type, this),
  distance_ (distance, this),
  radius_ (radius, this),
  center_ (center, this),
  velocity_ (velocity, this)
{
}

sphere_2Dz::
sphere_2Dz (const type_type& type,
            const distance_type& distance,
            const radius_type& radius,
            ::std::unique_ptr< center_type > center,
            ::std::unique_ptr< velocity_type > velocity)
: ::xml_schema::type (),
  type_ (type, this),
  distance_ (distance, this),
  radius_ (radius, this),
  center_ (std::move (center), this),
  velocity_ (std::move (velocity), this)
{
}

sphere_2Dz::
sphere_2Dz (const sphere_2Dz& x,
            ::xml_schema::flags f,
            ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  type_ (x.type_, f, this),
  distance_ (x.distance_, f, this),
  radius_ (x.radius_, f, this),
  center_ (x.center_, f, this),
  velocity_ (x.velocity_, f, this)
{
}

sphere_2Dz::
sphere_2Dz (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f,
            ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  type_ (this),
  distance_ (this),
  radius_ (this),
  center_ (this),
  velocity_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void sphere_2Dz::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // type
    //
    if (n.name () == "type" && n.namespace_ ().empty ())
    {
      if (!type_.present ())
      {
        this->type_.set (type_traits::create (i, f, this));
        continue;
      }
    }

    // distance
    //
    if (n.name () == "distance" && n.namespace_ ().empty ())
    {
      if (!distance_.present ())
      {
        this->distance_.set (distance_traits::create (i, f, this));
        continue;
      }
    }

    // radius
    //
    if (n.name () == "radius" && n.namespace_ ().empty ())
    {
      if (!radius_.present ())
      {
        this->radius_.set (radius_traits::create (i, f, this));
        continue;
      }
    }

    // center
    //
    if (n.name () == "center" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< center_type > r (
        center_traits::create (i, f, this));

      if (!center_.present ())
      {
        this->center_.set (::std::move (r));
        continue;
      }
    }

    // velocity
    //
    if (n.name () == "velocity" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< velocity_type > r (
        velocity_traits::create (i, f, this));

      if (!velocity_.present ())
      {
        this->velocity_.set (::std::move (r));
        continue;
      }
    }

    break;
  }

  if (!type_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "type",
      "");
  }

  if (!distance_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "distance",
      "");
  }

  if (!radius_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "radius",
      "");
  }

  if (!center_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "center",
      "");
  }

  if (!velocity_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "velocity",
      "");
  }
}

sphere_2Dz* sphere_2Dz::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class sphere_2Dz (*this, f, c);
}

sphere_2Dz& sphere_2Dz::
operator= (const sphere_2Dz& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->type_ = x.type_;
    this->distance_ = x.distance_;
    this->radius_ = x.radius_;
    this->center_ = x.center_;
    this->velocity_ = x.velocity_;
  }

  return *this;
}

sphere_2Dz::
~sphere_2Dz ()
{
}

// left_corner
//

left_corner::
left_corner (const left_corner_x_type& left_corner_x,
             const left_corner_y_type& left_corner_y,
             const left_corner_z_type& left_corner_z)
: ::xml_schema::type (),
  left_corner_x_ (left_corner_x, this),
  left_corner_y_ (left_corner_y, this),
  left_corner_z_ (left_corner_z, this)
{
}

left_corner::
left_corner (const left_corner& x,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  left_corner_x_ (x.left_corner_x_, f, this),
  left_corner_y_ (x.left_corner_y_, f, this),
  left_corner_z_ (x.left_corner_z_, f, this)
{
}

left_corner::
left_corner (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  left_corner_x_ (this),
  left_corner_y_ (this),
  left_corner_z_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void left_corner::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // left_corner_x
    //
    if (n.name () == "left_corner_x" && n.namespace_ ().empty ())
    {
      if (!left_corner_x_.present ())
      {
        this->left_corner_x_.set (left_corner_x_traits::create (i, f, this));
        continue;
      }
    }

    // left_corner_y
    //
    if (n.name () == "left_corner_y" && n.namespace_ ().empty ())
    {
      if (!left_corner_y_.present ())
      {
        this->left_corner_y_.set (left_corner_y_traits::create (i, f, this));
        continue;
      }
    }

    // left_corner_z
    //
    if (n.name () == "left_corner_z" && n.namespace_ ().empty ())
    {
      if (!left_corner_z_.present ())
      {
        this->left_corner_z_.set (left_corner_z_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!left_corner_x_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "left_corner_x",
      "");
  }

  if (!left_corner_y_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "left_corner_y",
      "");
  }

  if (!left_corner_z_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "left_corner_z",
      "");
  }
}

left_corner* left_corner::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class left_corner (*this, f, c);
}

left_corner& left_corner::
operator= (const left_corner& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->left_corner_x_ = x.left_corner_x_;
    this->left_corner_y_ = x.left_corner_y_;
    this->left_corner_z_ = x.left_corner_z_;
  }

  return *this;
}

left_corner::
~left_corner ()
{
}

// velocity
//

velocity::
velocity (const velo_x_type& velo_x,
          const velo_y_type& velo_y,
          const velo_z_type& velo_z)
: ::xml_schema::type (),
  velo_x_ (velo_x, this),
  velo_y_ (velo_y, this),
  velo_z_ (velo_z, this)
{
}

velocity::
velocity (const velocity& x,
          ::xml_schema::flags f,
          ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  velo_x_ (x.velo_x_, f, this),
  velo_y_ (x.velo_y_, f, this),
  velo_z_ (x.velo_z_, f, this)
{
}

velocity::
velocity (const ::xercesc::DOMElement& e,
          ::xml_schema::flags f,
          ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  velo_x_ (this),
  velo_y_ (this),
  velo_z_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void velocity::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // velo_x
    //
    if (n.name () == "velo_x" && n.namespace_ ().empty ())
    {
      if (!velo_x_.present ())
      {
        this->velo_x_.set (velo_x_traits::create (i, f, this));
        continue;
      }
    }

    // velo_y
    //
    if (n.name () == "velo_y" && n.namespace_ ().empty ())
    {
      if (!velo_y_.present ())
      {
        this->velo_y_.set (velo_y_traits::create (i, f, this));
        continue;
      }
    }

    // velo_z
    //
    if (n.name () == "velo_z" && n.namespace_ ().empty ())
    {
      if (!velo_z_.present ())
      {
        this->velo_z_.set (velo_z_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!velo_x_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "velo_x",
      "");
  }

  if (!velo_y_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "velo_y",
      "");
  }

  if (!velo_z_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "velo_z",
      "");
  }
}

velocity* velocity::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class velocity (*this, f, c);
}

velocity& velocity::
operator= (const velocity& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->velo_x_ = x.velo_x_;
    this->velo_y_ = x.velo_y_;
    this->velo_z_ = x.velo_z_;
  }

  return *this;
}

velocity::
~velocity ()
{
}

// dimensions
//

dimensions::
dimensions (const dim_x_type& dim_x,
            const dim_y_type& dim_y,
            const dim_z_type& dim_z)
: ::xml_schema::type (),
  dim_x_ (dim_x, this),
  dim_y_ (dim_y, this),
  dim_z_ (dim_z, this)
{
}

dimensions::
dimensions (const dimensions& x,
            ::xml_schema::flags f,
            ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  dim_x_ (x.dim_x_, f, this),
  dim_y_ (x.dim_y_, f, this),
  dim_z_ (x.dim_z_, f, this)
{
}

dimensions::
dimensions (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f,
            ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  dim_x_ (this),
  dim_y_ (this),
  dim_z_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void dimensions::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // dim_x
    //
    if (n.name () == "dim_x" && n.namespace_ ().empty ())
    {
      if (!dim_x_.present ())
      {
        this->dim_x_.set (dim_x_traits::create (i, f, this));
        continue;
      }
    }

    // dim_y
    //
    if (n.name () == "dim_y" && n.namespace_ ().empty ())
    {
      if (!dim_y_.present ())
      {
        this->dim_y_.set (dim_y_traits::create (i, f, this));
        continue;
      }
    }

    // dim_z
    //
    if (n.name () == "dim_z" && n.namespace_ ().empty ())
    {
      if (!dim_z_.present ())
      {
        this->dim_z_.set (dim_z_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!dim_x_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "dim_x",
      "");
  }

  if (!dim_y_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "dim_y",
      "");
  }

  if (!dim_z_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "dim_z",
      "");
  }
}

dimensions* dimensions::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class dimensions (*this, f, c);
}

dimensions& dimensions::
operator= (const dimensions& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->dim_x_ = x.dim_x_;
    this->dim_y_ = x.dim_y_;
    this->dim_z_ = x.dim_z_;
  }

  return *this;
}

dimensions::
~dimensions ()
{
}

// center
//

center::
center (const center_x_type& center_x,
        const center_y_type& center_y,
        const center_z_type& center_z)
: ::xml_schema::type (),
  center_x_ (center_x, this),
  center_y_ (center_y, this),
  center_z_ (center_z, this)
{
}

center::
center (const center& x,
        ::xml_schema::flags f,
        ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  center_x_ (x.center_x_, f, this),
  center_y_ (x.center_y_, f, this),
  center_z_ (x.center_z_, f, this)
{
}

center::
center (const ::xercesc::DOMElement& e,
        ::xml_schema::flags f,
        ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  center_x_ (this),
  center_y_ (this),
  center_z_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void center::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // center_x
    //
    if (n.name () == "center_x" && n.namespace_ ().empty ())
    {
      if (!center_x_.present ())
      {
        this->center_x_.set (center_x_traits::create (i, f, this));
        continue;
      }
    }

    // center_y
    //
    if (n.name () == "center_y" && n.namespace_ ().empty ())
    {
      if (!center_y_.present ())
      {
        this->center_y_.set (center_y_traits::create (i, f, this));
        continue;
      }
    }

    // center_z
    //
    if (n.name () == "center_z" && n.namespace_ ().empty ())
    {
      if (!center_z_.present ())
      {
        this->center_z_.set (center_z_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!center_x_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "center_x",
      "");
  }

  if (!center_y_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "center_y",
      "");
  }

  if (!center_z_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "center_z",
      "");
  }
}

center* center::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class center (*this, f, c);
}

center& center::
operator= (const center& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->center_x_ = x.center_x_;
    this->center_y_ = x.center_y_;
    this->center_z_ = x.center_z_;
  }

  return *this;
}

center::
~center ()
{
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

::std::unique_ptr< ::part_data_t >
part_data (const ::std::string& u,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::part_data_t > (
    ::part_data (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::part_data_t >
part_data (const ::std::string& u,
           ::xml_schema::error_handler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::part_data_t > (
    ::part_data (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::part_data_t >
part_data (const ::std::string& u,
           ::xercesc::DOMErrorHandler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::part_data_t > (
    ::part_data (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::part_data_t >
part_data (::std::istream& is,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::part_data (isrc, f, p);
}

::std::unique_ptr< ::part_data_t >
part_data (::std::istream& is,
           ::xml_schema::error_handler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::part_data (isrc, h, f, p);
}

::std::unique_ptr< ::part_data_t >
part_data (::std::istream& is,
           ::xercesc::DOMErrorHandler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::part_data (isrc, h, f, p);
}

::std::unique_ptr< ::part_data_t >
part_data (::std::istream& is,
           const ::std::string& sid,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::part_data (isrc, f, p);
}

::std::unique_ptr< ::part_data_t >
part_data (::std::istream& is,
           const ::std::string& sid,
           ::xml_schema::error_handler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::part_data (isrc, h, f, p);
}

::std::unique_ptr< ::part_data_t >
part_data (::std::istream& is,
           const ::std::string& sid,
           ::xercesc::DOMErrorHandler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::part_data (isrc, h, f, p);
}

::std::unique_ptr< ::part_data_t >
part_data (::xercesc::InputSource& i,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::part_data_t > (
    ::part_data (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::part_data_t >
part_data (::xercesc::InputSource& i,
           ::xml_schema::error_handler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::part_data_t > (
    ::part_data (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::part_data_t >
part_data (::xercesc::InputSource& i,
           ::xercesc::DOMErrorHandler& h,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::part_data_t > (
    ::part_data (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::part_data_t >
part_data (const ::xercesc::DOMDocument& doc,
           ::xml_schema::flags f,
           const ::xml_schema::properties& p)
{
  if (f & ::xml_schema::flags::keep_dom)
  {
    ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
      static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

    return ::std::unique_ptr< ::part_data_t > (
      ::part_data (
        std::move (d), f | ::xml_schema::flags::own_dom, p));
  }

  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (n.name () == "part_data" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::part_data_t > r (
      ::xsd::cxx::tree::traits< ::part_data_t, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "part_data",
    "");
}

::std::unique_ptr< ::part_data_t >
part_data (::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d,
           ::xml_schema::flags f,
           const ::xml_schema::properties&)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > c (
    ((f & ::xml_schema::flags::keep_dom) &&
     !(f & ::xml_schema::flags::own_dom))
    ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
    : 0);

  ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (f & ::xml_schema::flags::keep_dom)
    doc.setUserData (::xml_schema::dom::tree_node_key,
                     (c.get () ? &c : &d),
                     0);

  if (n.name () == "part_data" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::part_data_t > r (
      ::xsd::cxx::tree::traits< ::part_data_t, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "part_data",
    "");
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

